Subject: [Tools-discuss] issue with id-nits

From: Fred Baker <[email-masked]>
Date: Fri, 4 Jun 2010 12:59:55 -0700

Houston, we have a problem...

The authors of draft-ietf-v6ops-cpe-simple-security and draft-ietf-v6ops-ipv6-cpe-router checked their drafts against http://tools.ietf.org/tools/idnits/ and came up with at most a couple of glitches like 

> tmp/draft-ietf-v6ops-ipv6-cpe-router-05.txt(351): Unexpected reference format: '...ent ([RFC4862]/[RFC...'

When I do the same, I get something like

> idnits 2.12.04 
> 
> tmp/draft-ietf-v6ops-ipv6-cpe-router-05.txt:
> tmp/draft-ietf-v6ops-ipv6-cpe-router-05.txt(317): RFC 2119 keyword:    G-2:  The IPv6 CE router MUST implement ICMP according to [RFC4443]..
> tmp/draft-ietf-v6ops-ipv6-cpe-router-05.txt(318): RFC 2119 keyword:          In particular point to point links MUST be handled as described.
> tmp/draft-ietf-v6ops-ipv6-cpe-router-05.txt(321): RFC 2119 keyword:    G-3:  The IPv6 CE router MUST NOT forward any IPv6 traffic between.
> tmp/draft-ietf-v6ops-ipv6-cpe-router-05.txt(349): RFC 2119 keyword:    W-1:  When the router is attached to the WAN interface link it MUST.
> tmp/draft-ietf-v6ops-ipv6-cpe-router-05.txt(351): Unexpected reference format: '...ent ([RFC4862]/[RFC...'
>   -->          interface address assignment ([RFC4862]/[RFC3315]).
>                                              ^
> tmp/draft-ietf-v6ops-ipv6-cpe-router-05.txt(353): RFC 2119 keyword:    W-2:  The IPv6 CE router MUST generate a link-local address and.
> tmp/draft-ietf-v6ops-ipv6-cpe-router-05.txt(356): RFC 2119 keyword:          source address used in the subsequent Router Solicitation MUST.
> tmp/draft-ietf-v6ops-ipv6-cpe-router-05.txt(359): RFC 2119 keyword:    W-3:  Absent of other routing information the IPv6 CE router MUST use.
> tmp/draft-ietf-v6ops-ipv6-cpe-router-05.txt(364): RFC 2119 keyword:    W-4:  The router MUST act as a requesting router for the purposes of.
> tmp/draft-ietf-v6ops-ipv6-cpe-router-05.txt(368): RFC 2119 keyword:          (IA_PD) SHOULD be done as a single DHCPv6 session..
> tmp/draft-ietf-v6ops-ipv6-cpe-router-05.txt(373): RFC 2119 keyword:            the IPv6 CE router MUST support IPv6 over Ethernet [RFC2464]..
> tmp/draft-ietf-v6ops-ipv6-cpe-router-05.txt(376): RFC 2119 keyword:            router MUST support IPv6 over PPP [RFC5072]..
> tmp/draft-ietf-v6ops-ipv6-cpe-router-05.txt(380): RFC 2119 keyword:            logical channel, the NCPs MUST be treated as independent of.
> tmp/draft-ietf-v6ops-ipv6-cpe-router-05.txt(396): RFC 2119 keyword:    WAA-1:  The IPv6 CE router MUST support SLAAC [RFC4862]..
> tmp/draft-ietf-v6ops-ipv6-cpe-router-05.txt(398): RFC 2119 keyword:    WAA-2:  The IPv6 CE router MUST follow the recommendation in.
> tmp/draft-ietf-v6ops-ipv6-cpe-router-05.txt(403): RFC 2119 keyword:    WAA-3:  The IPv6 CE router MUST support DHCPv6 [RFC3315] client.
> tmp/draft-ietf-v6ops-ipv6-cpe-router-05.txt(406): RFC 2119 keyword:    WAA-4:  The IPv6 CE router MUST be able to support the following.
> tmp/draft-ietf-v6ops-ipv6-cpe-router-05.txt(410): RFC 2119 keyword:    WAA-5:  The IPv6 CE router SHOULD support the DHCPv6 SNTP option.
> tmp/draft-ietf-v6ops-ipv6-cpe-router-05.txt(414): RFC 2119 keyword:            [RFC4861]) with the M-flag set to 1, the IPv6 CE router MUST.
> tmp/draft-ietf-v6ops-ipv6-cpe-router-05.txt(418): RFC 2119 keyword:            SLAAC it MAY do DHCPv6 address assignment (request an IA_NA).
> tmp/draft-ietf-v6ops-ipv6-cpe-router-05.txt(422): RFC 2119 keyword:            address(es) from either SLAAC or DHCPv6, then it MUST create.
> tmp/draft-ietf-v6ops-ipv6-cpe-router-05.txt(427): RFC 2119 keyword:    WAA-9:  As a router the IPv6 CE router MUST follow the weak host.
> tmp/draft-ietf-v6ops-ipv6-cpe-router-05.txt(435): RFC 2119 keyword:    WPD-1:  The IPv6 CE router MUST support DHCPv6 prefix delegation.
> tmp/draft-ietf-v6ops-ipv6-cpe-router-05.txt(439): RFC 2119 keyword:    WPD-2:  The IPv6 CE router MAY indicate as a hint to the delegating.
> tmp/draft-ietf-v6ops-ipv6-cpe-router-05.txt(440): RFC 2119 keyword:            router the size of the prefix it requires.  If so, it MUST.
> tmp/draft-ietf-v6ops-ipv6-cpe-router-05.txt(442): RFC 2119 keyword:            its interfaces rounded up to the nearest nibble and MUST be.
> tmp/draft-ietf-v6ops-ipv6-cpe-router-05.txt(452): RFC 2119 keyword:    WPD-3:  The IPv6 CE router MUST be prepared to accept a delegated.
> tmp/draft-ietf-v6ops-ipv6-cpe-router-05.txt(455): RFC 2119 keyword:            interfaces, the IPv6 CE router SHOULD log a system management.
> tmp/draft-ietf-v6ops-ipv6-cpe-router-05.txt(458): RFC 2119 keyword:    WPD-4:  The IPv6 CE router MUST always initiate DHCPv6 prefix.
> tmp/draft-ietf-v6ops-ipv6-cpe-router-05.txt(463): RFC 2119 keyword:            Router Advertisement it MUST also request an IA_NA option in.
> tmp/draft-ietf-v6ops-ipv6-cpe-router-05.txt(467): RFC 2119 keyword:            multiple, more-specific routes, the IPv6 CE router MUST.
> tmp/draft-ietf-v6ops-ipv6-cpe-router-05.txt(475): RFC 2119 keyword:            (a)  The IPv6 CE router SHOULD send an ICMPv6 Destination.
> tmp/draft-ietf-v6ops-ipv6-cpe-router-05.txt(481): RFC 2119 keyword:            DHCPv6, it MUST accept an IA_PD in DHCPv6 Advertise/Reply.
> tmp/draft-ietf-v6ops-ipv6-cpe-router-05.txt(485): RFC 2119 keyword:    WPD-8:  By default an IPv6 CE router MUST NOT initiate any dynamic.
> tmp/draft-ietf-v6ops-ipv6-cpe-router-05.txt(525): RFC 2119 keyword:    L-1:   The IPv6 CE router MUST support ULA addressing [RFC4193]..
> tmp/draft-ietf-v6ops-ipv6-cpe-router-05.txt(527): RFC 2119 keyword:    L-2:   The IPv6 CE router MUST have a ULA prefix that it maintains.
> tmp/draft-ietf-v6ops-ipv6-cpe-router-05.txt(530): RFC 2119 keyword:    L-3:   The value of the ULA prefix SHOULD be user configurable..
> tmp/draft-ietf-v6ops-ipv6-cpe-router-05.txt(532): RFC 2119 keyword:    L-4:   By default the IPv6 CE router MUST act as a site border router.
> tmp/draft-ietf-v6ops-ipv6-cpe-router-05.txt(536): RFC 2119 keyword:    L-5:   The IPv6 CE router MUST support router behavior according to.
> tmp/draft-ietf-v6ops-ipv6-cpe-router-05.txt(539): RFC 2119 keyword:    L-6:   The IPv6 CE router MUST assign a separate /64 from its.
> tmp/draft-ietf-v6ops-ipv6-cpe-router-05.txt(543): RFC 2119 keyword:    L-7:   The IPv6 CE router MUST make each LAN interface an advertising.
> tmp/draft-ietf-v6ops-ipv6-cpe-router-05.txt(547): RFC 2119 keyword:           Option's A and L-flags MUST be set to 1 by default..
> tmp/draft-ietf-v6ops-ipv6-cpe-router-05.txt(549): RFC 2119 keyword:    L-9:   The A and L-flags setting SHOULD be user configurable..
> tmp/draft-ietf-v6ops-ipv6-cpe-router-05.txt(551): RFC 2119 keyword:    L-10:  The IPv6 CE router MUST support a DHCPv6 server capable of.
> tmp/draft-ietf-v6ops-ipv6-cpe-router-05.txt(565): RFC 2119 keyword:           IA_NA option, it SHOULD set M=0 and O=1 in its Router.
> tmp/draft-ietf-v6ops-ipv6-cpe-router-05.txt(568): RFC 2119 keyword:    L-12:  The IPv6 CE router MUST support providing DNS information in.
> tmp/draft-ietf-v6ops-ipv6-cpe-router-05.txt(571): RFC 2119 keyword:    L-13:  The IPv6 CE router SHOULD make available a subset of DHCPv6.
> tmp/draft-ietf-v6ops-ipv6-cpe-router-05.txt(578): RFC 2119 keyword:           period, then the IPv6 CE router MUST immediately advertise the.
> tmp/draft-ietf-v6ops-ipv6-cpe-router-05.txt(583): RFC 2119 keyword:    L-15:  The IPv6 CE router MUST send an ICMP Destination Unreachable.
> tmp/draft-ietf-v6ops-ipv6-cpe-router-05.txt(600): RFC 2119 keyword:    S-1:  The IPv6 CE router SHOULD support.
> tmp/draft-ietf-v6ops-ipv6-cpe-router-05.txt(603): RFC 2119 keyword:    S-2:  The IPv6 CE router MUST support ingress filtering in accordance.
> tmp/draft-ietf-v6ops-ipv6-cpe-router-05.txt(604): Unexpected reference format: '...with [RFC2827](BCP ...'
>   -->          with [RFC2827](BCP 38)

The file contains the specified reference to RFC 2119, in section 1.1 in both cases, and we are using the same version of the checker.

Help? I'm going to file the report saying that id-nits is wrong, which I would rather not do.

---

From: Henrik Levkowetz <[email-masked]>
Date: Wed, 23 Jun 2010 14:24:35 +0200

Hi,

The list of RFC keywords found in --verbose --verbose mode is not in any
way an error or warning from idnits, it's just one of many possible verbose
messages emitted in the very verbose mode.

Only if idnits explicitly indicates a non-zero error or warning count do
you have to consider there being errors or warnings associated with the
draft.

Best,

	Henrik

On 2010-06-04 21:59 Fred Baker said:
> _______________________________________________
> Tools-discuss mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/tools-discuss
>

---

From: Fred Baker <[email-masked]>
Date: Thu, 24 Jun 2010 00:29:18 +0200

Thanks. That's not obvious from the output.

>> Help? I'm going to file the report saying that id-nits is wrong, which I would rather not do.

http://www.ipinc.net/IPv4.GIF